/* Copyright 1992 NEC Corporation, Tokyo, Japan.
 *
 * Permission to use, copy, modify, distribute and sell this software
 * and its documentation for any purpose is hereby granted without
 * fee, provided that the above copyright notice appear in all copies
 * and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of NEC
 * Corporation not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior
 * permission.  NEC Corporation makes no representations about the
 * suitability of this software for any purpose.  It is provided "as
 * is" without express or implied warranty.
 *
 * NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN 
 * NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
 * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR 
 * OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
 * PERFORMANCE OF THIS SOFTWARE. 
 *
 *  Author : Osamu Hata, NEC Corporation  (hata@d1.bs2.mt.nec.co.jp)
 *
 */

/*
static	char	rcs_id[] = "@(#) 102.1 $Id: ccustom.h,v 1.1.1.1 2002/10/19 08:27:30 aida_s Exp $";
*/

#include "symbolname.h"

#define NHENKAN_MAX 9999

extern char *kanjidicname[], *userdicname[],  *bushudicname[], *localdicname[]; 
extern int  nkanjidics, nuserdics, nbushudics, nlocaldics;
extern char  *RomkanaTable, *RengoGakushu, *KatakanaGakushu;
extern int InitialMode, CursorWrap, SelectDirect, HexkeySelect, BunsetsuKugiri;
extern int ChBasedMove, ReverseWidely, Gakushu, QuitIchiranIfEnd;
extern int kakuteiIfEndOfBunsetsu, stayAfterValidate, BreakIntoRoman;
extern int kouho_threshold, gramaticalQuestion;
extern char *mode_mei[], null_mode[];
int forceKana, kCount, chikuji, iListCB ,nKouhoBunsetsu;
int keepCursorPosition, CannaVersion, abandonIllegalPhono;
int hexCharacterDefiningStyle, kojin, ReverseWord , allowNextInput;
int indexhankaku,ignorecase,romajiyuusen,autosync,nkeysuu,quicklyescape;

extern char *allKey[], *alphaKey[], *yomiganaiKey[];
extern char *yomiKey[], *jishuKey[], *tankouhoKey[];
extern char *ichiranKey[], *zenHiraKey[], *zenKataKey[];
extern char *zenAlphaKey[], *hanKataKey[], *hanAlphaKey[];
extern char *allFunc[], *alphaFunc[], *yomiganaiFunc[];
extern char *yomiFunc[], *jishuFunc[], *tankouhoFunc[];
extern char *ichiranFunc[], *zenHiraFunc[], *zenKataFunc[];
extern char *zenAlphaFunc[], *hanKataFunc[], *hanAlphaFunc[];
extern int NallKeyFunc, NalphaKeyFunc, NyomiganaiKeyFunc, NyomiKeyFunc;
extern int NjishuKeyFunc, NtankouhoKeyFunc,  NichiranKeyFunc;
extern int NzenHiraKeyFunc, NzenKataKeyFunc, NzenAlphaKeyFunc;
extern int NhanKataKeyFunc, NhanAlphaKeyFunc;
extern char returnKey[];
extern char *funcList[];
extern char *cfuncList[];

char **fList;

char etc_ctm[32];
char **etc_menu;
char **etc_manual;

char **current_acts, **current_keys;
char err_mess[255];
char *initFileSpecified =(char *)NULL;

int is_icustom;
int junban;

char *old_mode_ichiran[] = {
  "ե٥åȥ⡼",
  "[] Ѵϥ⡼",
  "[] ɽ",
  "[] ѤҤ餬ʳϥ⡼",
  "[] ѥʳϥ⡼",
  "[] Ⱦѥʳϥ⡼",
  "[] ѥե٥åȳϥ⡼",
  "[a] Ⱦѥե٥åȳϥ⡼",
  "[] ɤϾ",
  "[] ʸѴ",
  "[] ñɽ",
  "[] ɽ",
  "[] ñϿʸɽ",
  "[] ñϿʸɽ",
  "[] ѥѴϥ⡼",
  "[] ȾѥѴϥ⡼",
  "[] ѥե٥åѴϥ⡼",
  "[a] Ⱦѥե٥åѴϥ⡼",
  "[16] ʥϾ",
  "[] ɤϾ",
  "[ĥ] ĥǽ",
  "[] ʸ",
  "[] ꥷʸ",
  "[] ",
  "[ѹ] ѹ",
  "[Ѵ] Ѵ",
  "[] ñ",
  "[Ͽ] ñϿ⡼",
  "[ʻ] ñϿ⡼ɤʻ",
  "[] ñϿ⡼ɤμ",
  "[] ϥ⡼",
  "[Խ] Խ⡼",
  "[] ΥޥȡޥȾ",
  NULL
};

char *old_mode_ichiran2[] = {
  "alphaMode",
  "henkanNyuryokuMode",
  "[] ɽ",
  "zenHiraKakuteiMode",
  "zenKataKakuteiMode",
  "hanKataKakuteiMode",
  "zenAlphaKakuteiMode",
  "hanAlphaKakuteiMode",
  "[] ɤϾ",
  "[] ʸѴ",
  "[] ñɽ",
  "[] ɽ",
  "[] ñϿʸɽ",
  "[] ñϿʸɽ",
  "zenKataHenkanMode",
  "hanKataHenkanMode",
  "zenAlphaHenkanMode",
  "hanAlphaHenkanMode",
  "[16] ʥϾ",
  "[] ɤϾ",
  "[ĥ] ĥǽ",
  "[] ʸ",
  "[] ꥷʸ",
  "[] ",
  "[ѹ] ѹ",
  "[Ѵ] Ѵ",
  "[] ñ",
  "[Ͽ] ñϿ⡼",
  "[ʻ] ñϿ⡼ɤʻ",
  "[] ñϿ⡼ɤμ",
  "[] ϥ⡼",
  "[Խ] Խ⡼",
  "[] ΥޥȡޥȾ",
  NULL
};

char *mode_ichiran3[] = {
  S_AlphaMode,
  S_YomiganaiMode,
  S_KigouMode,
  S_YomiMode,
  S_MojishuMode,
  S_TankouhoMode,
  S_IchiranMode,
  S_YesNoMode,
  S_OnOffMode,
  "S_AdjustBunsetsu",
  S_AutoYomiMode,
  S_AutoBunsetsuMode,
  S_HenkanNyuuryokuMode,
  S_ZenHiraHenkanMode,
  S_HanHiraHenkanMode,
  S_ZenKataHenkanMode,
  S_HanKataHenkanMode,
  S_ZenAlphaHenkanMode,
  S_HanAlphaHenkanMode,
  S_ZenHiraKakuteiMode,
  S_HanHiraKakuteiMode,
  S_ZenKataKakuteiMode,
  S_HanKataKakuteiMode,
  S_ZenAlphaKakuteiMode,
  S_HanAlphaKakuteiMode,
  S_HexMode,
  S_BushuMode,
  S_ExtendMode,
  S_RussianMode,
  S_GreekMode,
  S_LineMode,
  S_ChangingServerMode,
  S_HenkanMethodMode,
  S_DeleteDicMode,
  S_TourokuMode,
  S_TourokuHinshiMode,
  S_TourokuDicMode,
  S_QuotedInsertMode,
  S_BubunMuhenkanMode,
  S_MountDicMode,
  NULL
};

char *mode_ichiran[] = {
  "ե٥åȥ⡼",
  "[  ] Ѵϥ⡼",
  "[] ɽ",
  "<> ѤҤ餬ʳϥ⡼",
  "<> ѥʳϥ⡼",
  "<Ⱦ> Ⱦѥʳϥ⡼",
  "<> ѥե٥åȳϥ⡼",
  "<> Ⱦѥե٥åȳϥ⡼",
  "[  ] ɤϾ",
  "[] ʸѴ",
  "[] ñɽ",
  "[] ɽ",
  "[] ñϿʸɽ",
  "[] ñϿʸɽ",
  "[] ѥѴϥ⡼",
  "[Ⱦ] ȾѥѴϥ⡼",
  "[] ѥե٥åѴϥ⡼",
  "[Ⱦ] Ⱦѥե٥åѴϥ⡼",
  "[16] ʥϾ",
  "[] ɤϾ",
  "[ĥ] ĥǽ",
  "[  ] ʸ",
  "[  ] ꥷʸ",
  "[] ",
  "[ѹ] ѹ",
  "[Ѵ] Ѵ",
  "[] ñ",
  "[Ͽ] ñϿ⡼",
  "[ʻ] ñϿ⡼ɤʻ",
  "[] ñϿ⡼ɤμ",
  "[  ] ϥ⡼",
  "[Խ] Խ⡼",
  "[] ΥޥȡޥȾ",
  NULL
};

char *mode_ichiran2[] = {
  NULL,
  "",
  "[] ɽ",
  S_ZenHiraKakuteiMode,
  S_ZenKataKakuteiMode,
  S_HanKataKakuteiMode,
  S_ZenAlphaKakuteiMode,
  S_HanAlphaKakuteiMode,
  "[  ] ɤϾ",
  "[] ʸѴ",
  "[] ñɽ",
  "[] ɽ",
  "[] ñϿʸɽ",
  "[] ñϿʸɽ",
  S_ZenKataHenkanMode,
  S_HanKataHenkanMode,
  S_ZenAlphaHenkanMode,
  S_HanAlphaHenkanMode,
  "[16] ʥϾ",
  "[] ɤϾ",
  "[ĥ] ĥǽ",
  "[  ] ʸ",
  "[  ] ꥷʸ",
  "[] ",
  "[ѹ] ѹ",
  "[Ѵ] Ѵ",
  "[] ñ",
  "[Ͽ] ñϿ⡼",
  "[ʻ] ñϿ⡼ɤʻ",
  "[] ñϿ⡼ɤμ",
  "[  ] ϥ⡼",
  "[Խ] Խ⡼",
  "[] ΥޥȡޥȾ",
  NULL
};

char *old_mode_ichiran3[] = {
  "Alpha",
  "HenkanNyuryoku",
  "Kigo",
  "ZenHiraKakutei",
  "ZenKataKakutei",
  "HanKataKakutei",
  "ZenAlphaKakutei",
  "HanAlphaKakutei",
  "Yomi",
  "Mojishu",
  "Tankouho",
  "Ichiran",
  "YesNo",
  "YesNo",
  "ZenKataHenkan",
  "HanKataHenkan",
  "ZenAlphaHenkan",
  "HanAlphaHenkan",
  "Hex",
  "Bushu",
  "Extend",
  "Russian",
  "Greek",
  "Line",
  "ChangingServer",
  "HenkanMethod",
  "DeleteDic",
  "Touroku",
  "TourokuHinshi",
  "TourokuDic",
  "QuotedInsert",
  "BubunMuhenkan",
  "MountDic",
  NULL
};

char mode_set[] = { 0, 1, 3, 4, 6, 5, 7, 1, 14, 16, 15, 17, -1};

char *base_menu[] = {
  "ޥեɤ߹",
  "ޥեؤ¸",
  "Ѥ뼭",
  "Υޥ",
  "⡼ɤɽʸΥޥ",
  "¾Υޥ",
  "λ",
  NULL
};

char *d_mess[] = {
  "μذưĥڡ,ţӣå",
  "Ͽɽذưĥڡ",
  "Ͽļμ֤ǥ꥿󥭡",
  "ļϿɽ֤ǣĥ",
  "Ѥ뼭λļμ֤ǣţӣå",
  NULL
};

char *dic_menu[] = {
  "޻Ѵơ֥",
  "ƥ༭̾",
  "Ѵ̾",
  "桼̾",
/*
  "ϢѴ̾",
*/
  NULL
};

char *key_menu[] = {
  "ƤΥ⡼",
  "ե٥åȥ⡼",
  "Ѵϥ⡼(ɤϻ)",
  "Ѵϥ⡼(ɤϻ)",
  "ʸѴ",
  "ñɽ",
  "ɽ",
  "ѤҤ餬ʳϥ⡼",
  "ѥʳϥ⡼",
  "ѥե٥åȳϥ⡼",
  "Ⱦѥʳϥ⡼",
  "Ⱦѥե٥åȳϥ⡼",
  NULL
};

char *kh_mess[] = {
  "ޥϡֿפ塢꥿󥭡򲡤",
  "ǽϡֿǽפ塢꥿󥭡򲡤",
  "",
  "ޥԽѹʬ塢",
  "ĥ򲡤",
  "Ժ˥򲡤",
  "ɥ򲡤",
  "ɲá򲡤",
  "Υ⡼ɤȴ롧ţӣåѥ򲡤",
  NULL
};

struct dk_block {
  char *str;
  int len;
  int gyousu;
  int keysu;
  int actsu;
} dk_blocks[1024];

struct U_dk_block {
  char str[256];
  int len;
  int gyousu;
  int keysu;
  int actsu;
} U_dk_blocks;

struct wdisp {
  int top;
  int line;
  int kora;
  int ban;
  int current;
} WDisp, U_WDisp;

char *cc_keys[1], *cc_acts[1];
char ccc_keys[256], ccc_acts[256];
char undo_keys[256], undo_acts[256];
int  cc_keys_len = 0, cc_acts_len = 0;
int touroku_start = -1;
int undo_status = -1, undo_ts;

char *key_iroha[] = {
  "all",
  "alpha",
  "yomiganai",
  "yomi",
  "mojishu",
  "tankouho",
  "ichiran",
  "zenHiraKakutei",
  "zenKataKakutei",
  "zenAlphaKakutei",
  "hanKataKakutei",
  "hanAlphaKakutei",
  NULL
  };

char *keyLine[] = {
  "C-@  C-a  C-b  C-c  C-d  C-e  C-f  C-g  C-h  C-i  C-j  C-k",
  "C-l  C-m  C-n  C-o  C-p  C-q  C-r  C-s  C-t  C-u  C-v  C-w",
  "C-x  C-y  C-z  C-[  C-\\  C-]  C-^  C-_  space  !  \"  #  $  %",
  "&  '  (  )  *  +  ,  -  .  /  0  1  2  3  4  5  6  7  8  9",
  ":  ;  <  =  >  ?  @  A  B  C  D  E  F  G  H  I  J  K  L  M",
  "N  O  P  Q  R  S  T  U  V  W  X  Y  Z  [  \\  ]  ^  _  `  a",
  "b  c  d  e  f  g  h  i  j  k  l  m  n  o  p  q  r  s  t  u",
  "v  w  x  y  z  {  |  }  ~  DEL  Nfer  Xfer  Up  Left  Right",
  "Down  Insert  Rollup  Rolldown  HOME  HELP  S-nfer  S-xfer",
  "S-up  S-left  S-right  S-down  C-nfer  C-xfer  C-up  C-left",
  "C-right  C-down  F1  F2  F3  F4  F5  F6  F7  F8  F9  F10",
  "PF1  PF2  PF3  PF4  undefine",
  NULL
};

char **actLine;

char *caLine[] = {
  "self-insert:ʸ",                             /*  2 */
  "quoted-insert:ΰʸ̵Ϥ",
  "japanese-mode:ܸ⡼ɤؤΰܹ",
  "alpha-mode:ե٥åȥ⡼ɤ˰ܹ",                      /*  5 */
  "henkan-nyuuryoku-mode:Ѵϥ⡼ɤ˰ܹ",
  "forward:ư()",
  "backward:ư()",
  "next:ʸѴ(ɤϤΤȤ)",
  "previous:ʸѴ(ɤϤΤȤ)",                /* 10 */
  "beginning-of-line:Ƭ(ü)",
  "end-of-line:(ü)",
  "delete-next:ʸõ",
  "delete-previous:ʸ",
  "kill-to-end-of-line:걦¦ʸޤǺ",   /* 15 */
  "henkan:Ѵ",
  "kakutei:",
  "extend:ΰ迭Ф",
  "shrink:ΰ̤",
  "shinshuku-mode:ʸ῭̥⡼ɤذܹ",                        /* 20 */
  "quit:",
  "convert-as-hex:ɤߤ16ʥɤȤߤʤѴ",
  "convert-as-bushu:ɤߤ̾ȤߤʤѴ",
  "kouho-ichiran:ɽ",
  "henshu:Խ",                                                /* 25 */
  "zenkaku:Ѵ",
  "hankaku:ȾѴ",
  "to-upper:ʸѴ",
  "capitalize:ƬʸΤߤʸˤ",
  "to-lower:ʸѴ",                                      /* 30 */
  "hiragana:Ҥ餬Ѵ",
  "katakana:Ѵ",
  "romaji:޻Ѵ",
  "base-hiragana:ϥ١Ҥ餬ʤˤ",
  "base-katakana:ϥ١򥫥ʤˤ",                   /* 35 */
  "base-eisu:ϥ١ѿˤ",
  "base-zenkaku:ϥ١Ѥˤ",
  "base-hankaku:ϥ١ȾѤˤ",
  "base-kana:ϥ١򥫥ʤˤ",
  "base-kakutei:ϥ⡼ɤ⡼ɤˤ",                  /* 40 */
  "base-henkan:ϥ⡼ɤѴ⡼ɤˤ",
  "base-hiragana-katakana-toggle:ϥ١Ҥ餬ʡʤǥȥ", 
  "base-zenkaku-hankaku-toggle:ϥ١ѤȾѤǥȥ",
  "base-kana-eisu-toggle:ϥ١򥫥ʤȱѿǥȥ",
  "base-kakutei-henkan-toggle:ϥ⡼ɤѴǥȥ",  /* 45 */
  "base-rotate-forward:ϥ⡼ɤ֤ڤؤ()",
  "base-rotate-backward:ϥ⡼ɤ֤ڤؤ(ս)",
  "extend-mode:桼ƥƥ˥塼˰ܹ",
  "hex-mode:ϥ⡼ɤ˰ܹ",
  "bushu-mode:ϥ⡼ɤ˰ܹ",                            /* 50 */
  "kigou-mode:ϥ⡼ɤ˰ܹ",
  "zen-hira-kakutei-mode:ѤҤ餬ʳ⡼ɤ˰ܹ",
  "zen-kata-kakutei-mode:ѥʳ⡼ɤ˰ܹ",
  "han-kata-kakutei-mode:Ⱦѥʳ⡼ɤ˰ܹ",
  "zen-alpha-kakutei-mode:ѥե٥åȳ⡼ɤ˰ܹ",  /* 55 */
  "han-alpha-kakutei-mode:Ⱦѥե٥åȳ⡼ɤ˰ܹ",
  "henkan-or-self-insert:١Ҥ餬ʰʳΤȤself-insert򤪤ʤ",
  "henkan-or-do-noting:١Ҥ餬ʰʳΤȤʤˤ⤷ʤ",
  "switch-server:Фڤؤ򤪤ʤ",
  "disconnect-server:ФȤ³ڤ",
  "show-server-name:̾ɽ",
  "show-gakushu:ؽ֤ɽ",
  "show-canna-version:Сɽ",
  "show-romkana-table:޻Ѵơ֥̾ɽ",
  "show-canna-file:ޥե̾ɽ",
  "sync-dicsyionary:˽񤭹",
  NULL
};

char *aLine[] = {
  "SelfInsert:ʸ",
  "QuotedInsert:ΰʸ̵Ϥ",
  "JapaneseMode:ܸ⡼ɤؤΰܹ",
  "AlphaMode:ե٥åȥ⡼ɤ˰ܹ",
  "HenkanNyuryokuMode:Ѵϥ⡼ɤ˰ܹ",
  "ZenHiraKakuteiMode:ѤҤ餬ʳ⡼ɤ˰ܹ",
  "ZenKataKakuteiMode:ѥʳ⡼ɤ˰ܹ",
  "HanKataKakuteiMode:Ⱦѥʳ⡼ɤ˰ܹ",
  "ZenAlphaKakuteiMode:ѥե٥åȳ⡼ɤ˰ܹ",
  "HanAlphaKakuteiMode:Ⱦѥե٥åȳ⡼ɤ˰ܹ",
  "HexMode:ʥϥ⡼ɤ˰ܹ",
  "BushuMode:ϥ⡼ɤ˰ܹ",
  "KigouMode:ϥ⡼ɤ˰ܹ",
  "Forward:ư()",
  "Backward:ư()",
  "Next:ʸѴ(ɤϤΤȤ)",
  "Previous:ʸѴ(ɤϤΤȤ)",
  "BeginningOfLine:Ƭ(ü)",
  "EndOfLine:(ü)",
  "DeleteNext:ʬʸ",
  "DeletePrevious:κʸ",
  "KillToEndOfLine:걦¦ʸޤǺ",
  "Henkan:Ѵ",
  "Kakutei:",
  "Extend:ΰ迭Фʸڤؤ(ɤϤΤȤ)",
  "Shrink:ΰ̤ᡢʸڤؤ(ɤϤΤȤ)",
  "Quit:",
  "Touroku:桼ƥƥ(ĥ)⡼ɤذܹ",
  "ConvertAsHex:ɤߤ16ʥɤȤߤʤѴ",
  "ConvertAsBushu:ɤߤ̾ȤߤʤѴ",
  "KouhoIchiran:ɽ",
  "BubunMuhenkan:ʬ̵Ѵ",
  "Zenkaku:ѤѴ",
  "Hankaku:ȾѤѴ",
  "ToUpper:ʸѴ",
  "Capitalize:ƬʸΤߤʸˤ",
  "ToLower:ʸѴ",
  "Hiragana:Ҥ餬ʤѴ",
  "Katakana:ʤѴ",
  "Romaji:޻Ѵ",
  "NextKouho:",
  "PrevKouho:",
  NULL
};

char *old_mode_menu[] = {
  "         ե٥åȥ⡼",
  "  []   Ѵϥ⡼",
  "[]   ѤҤ餬ʳϥ⡼",
  "[]   ѥʳϥ⡼",
  "[]    Ⱦѥʳϥ⡼",
  "[]   ѥե٥åȳϥ⡼",
  "[a]    Ⱦѥե٥åȳϥ⡼",
  "  [] ʸѴ",
  "  [] ñɽ",
  "  [] ɽ",
  "  []   ѥѴϥ⡼",
  "  []    ȾѥѴϥ⡼",
  "  []   ѥե٥åѴϥ⡼",
  "  [a]    Ⱦѥե٥åѴϥ⡼",
  "  [16] ʥϾ",
  "  [] ɤϾ",
  "  [] ɽ",
  "  [ĥ] ĥǽ",
  "  []   ʸ",
  "  []   ꥷʸ",
  "  [] ",
  "  [ѹ] ѹ",
  "  [] ñ",
  "  [Ͽ] ñϿ⡼",
  "  [ʻ] ñϿ⡼ɤʻ",
  "  [] ñϿ⡼ɤμ",
  "  []   ϥ⡼",
  "  [Խ] Խ⡼",
  "  [] ΥޥȡޥȾ",
  NULL
};

char *mode_menu[] = {
  "         ե٥åȥ⡼",
  "[  ]   Ѵϥ⡼",
  "<>   ѤҤ餬ʳϥ⡼",
  "<>   ѥʳϥ⡼",
  "<Ⱦ>   Ⱦѥʳϥ⡼",
  "<>   ѥե٥åȳϥ⡼",
  "<Ⱦ>   Ⱦѥե٥åȳϥ⡼",
  "[]   ʸѴ",
  "[]   ñɽ",
  "[]   ɽ",
  "[]   ѥѴϥ⡼",
  "[Ⱦ]   ȾѥѴϥ⡼",
  "[]   ѥե٥åѴϥ⡼",
  "[Ⱦ]   Ⱦѥե٥åѴϥ⡼",
  "[༡]   ༡ưѴɤʬ",
  "[༡]   ༡ưѴʸʬ",
  "[16]   ʥϾ",
  "[]   ɤϾ",
  "[]   ɽ",
  "[ĥ]   ĥǽ",
  "[  ]   ʸ",
  "[  ]   ꥷʸ",
  "[]   ",
  "[ѹ]   ѹ",
  "[]   ñ",
  "[Ͽ]   ñϿ⡼",
  "[ʻ]   ñϿ⡼ɤʻ",
  "[]   ñϿ⡼ɤμ",
  "[  ]   ϥ⡼",
  "[Խ]   Խ⡼",
  "[]   ΥޥȡޥȾ",
  NULL
};

char mm_set[] = { 0, 1, 3, 4, 5, 6, 7, 9, 10, 11, 14, 15, 16, 17, 18,
		     19, 2, 20, 21, 22, 23, 24, 26, 27, 28, 29, 30, 31, 32 };

char c_mm_set[] = { 0, 12, 19, 21, 22, 23, 24, 4, 5, 6, 15,
		      16, 17, 18, 10, 11,25, 26,2, 27, 28, 
		      29, 30, 31, 33, 34, 35, 36, 37, 38, 39 };

char *ce_menu[] = {
  "initialMode",
  "cursorWrap",
  "numericalKeySelect",
  "selectDirect",
  "bunsetsuKugiri",
  "characterBasedMove",
  "reverseWidely",
  "quitIfEndOfIchiran",
  "breakIntoRoman",
  "gakushu",
  "stayAfterValidate",
  "kakuteiIfEndOfBunsetsu",
  "gramaticalQuestion",
  "nHenkanForIchiran",
  "kouhoCount",
  "kojin",
  "auto",
  "nKouhoBunsetsu",
  "abandonIllegalPhono",
  "hexDirect",
  "allowNextInput",
  "indexHankaku",
  "ignoreCase",
  "romajiYuusen",
  "auto-sync",
  "nKeyToDisconnect",
  "quicklyEscape",
  NULL
};

char *e_menu[] = {
  "initialMode",
  "cursorWrap",
  "numericalKeySelect",
  "selectDirect",
  "bunsetsuKugiri",
  "characterBasedMove",
  "reverseWidely",
  "quitIfEndOfIchiran",
  "breakIntoRoman",
  "gakushu",
  "stayAfterValidate",
  "kakuteiIfEndOfBunsetsu",
  "gramaticalQuestion",
  "nHenkanForIchiran",
  NULL
};
  
#define ON   1
#define OFF -1
#define MID  2

char *ce_manual[] = {
  "  ưΥ⡼ɤ(,)ǻꤷޤǥեȤϥե٥å\
⡼ɤǤ",
  "  ɤߤϤƤ֤ǥư˱ü鱦\
ذư򤷤亸ü麸ذư򤷤\
ȿ¦Υ뤬ư뤳Ȥꤷޤonǰưoff\
ǰưޤ󡣥ǥեȤonǤ",
  "ǡѤƸǤ뤫ɤ\
ޤǥեȤonǤoffꤹȡΥ\
򤵤Ƥ䤬ꤷϼɤߤȤ\
갷ޤ",
  "numericalKeySelectonǤȤˡǸ򤷤Ȥ\
˸ɽΤޤޤǤʤꤷޤonξϸ\
λޤǥեȤonǤ",
  "ɽƤȤʸᤴȤ˶Ƕڤ뤫ɤ\
ޤonǶڤޤǥեȤoffǤ",
  "ɤߤϤƤȤ˥ưԤˡʸñ̤ǰư\
ԤɤꤷޤǥեȤonǤoffˤȡ޻\
Ѵγñ̤ˤƥưޤʸƱͤ\
Ԥޤ",
  "onꤹɤߤϤƤʸȿžϰϤʤޤ\
ǥեȤoffǤ",
  "ǺǽɽƤ֤ǼԤȸ\
λɤߤΤΤȤɽ褦ˤʤޤܤ\
ڡɽ˥ޥƤʤɤonˤƤ\
ǤǥեȤoffǤ",
  "ХåڡǤäȤľΥ޻Ѵ줿ʸ\
޻뤫ɤꤷޤǥեȤoffǤ",
  "ʴѴؽԤɤꤷޤǥեȤonǤ",
  "֤Ǹ򤷤ñɽ֤äȤˡ\
ʸ򼡤ʸ˰ư뤫ɤꤷޤoffǥʸ˰ư\
ޤonǤϥʸѤޤ󡣥ǥեȤonǤ",
  "ǱʸǼʸذư褦ȤȤˡꤹ뤫ݤꤷޤ\
offꤹȺǺʸ᤬ʸˤʤޤǥեȤoffǤ",
  "ñϿʻꤷ塢ܺ٤ʻʬΤμԤݤ\
ꤷޤonǼԤoffǤϼ򤷤ޤ󡣥ǥեȤonǤ",
  "Ѵ򲿲󤫲ȸɽԤ褦ˤ\
ǤޤǤϤβ(,)ǻꤷޤ\
0ˤȲѴ\
ƤɽԤʤʤޤǥեȤ2ǡ2Ѵ\
Ȱɽˤʤޤ",
  "桼ƥƥǽɽ̤ʬθޤϥƥ\
ɽ뤫ʤꤷޤonɽoffɽʤʤޤ\
ǥեȤonǤ",
  "Ŀ̳ؽե뤬¸ߤ뼭ФơĿ̳ؽԤɤ\
ꤷޤonǹԤoffǹԤޤ󡣥ǥեȤonǸĿ̳ؽԤޤ",
  "Ѵ༡ưѴˤ뤫ʤꤷޤonǤ༡ưѴ\
ˤʤoffǤϢʸѴˤʤޤǥեȤoff(ϢʸѴ)Ǥ",
  "༡ưѴˤѴݻƤʸοꤷޤ\
ǥեȤ16ʸǤǽʿ332Ǥ ǤϤβ\
(,)ǻꤷޤ",
  "޻Ѵʥ޻ϤȤƻĤ뤫ɤꤷޤ\
onʥ޻ΤƤޤoffǤʥ޻ϻĤޤǥե\
offǤ",
  "Ϥˤ4Υɤϸ塢ʸꤹ뤫ʤ\
ꤷޤonǳꤷơoffǳꤷޤ󡣥ǥեȤoffǳ\
ޤ",
  "ɽ֤ǿʳΥ򲡤ˡߥ뤬֤\
䤬򤵤켡ϤȤʤ뤫ɤꤷޤ",
  "ֹʸȾʸѹ뤫ɤꤷޤǥեȤoffʸǤ", 
  "޻Ѵơ֥̾ʸϤȥե٥åȤΤޤϤ졢ʤˤѴޤonˤʸϤƤ޻ѴǤϾʸȤƼ갷ޤǥեȤoffǤ",
  "onˤϤ줿ʸ޻ѴͭȤʤ륭ǤСΥ˳ƤƤ뵡ǽǤ self-insert ʤޤǥեȤoffǤ",
  "ñϿӺ򤷤ȤưŪ˼ƱԤ뤫ɤꤷޤonˤƱԤޤǥեȤonǤ",
  "ե٥åȤϤ³ΥФȤ³ڤ륹ȥꤷޤǤϲ(,)ǻꤷޤ100ѲޤǥեȤ500Ǥ",
  "ϥ⡼ɤǵ򤷤⵭⡼ɤαޤ뤫ɤꤷޤoff ˤαޤޤ",
  NULL
};

char *e_manual[] = {
  "  ưΥ⡼ɤ(,)ǻꤷޤǥեȤϥե٥å\
⡼ɤǤ",
  "  ɤߤϤƤ֤ǥư˱ü鱦\
ذư򤷤亸ü麸ذư򤷤\
ȿ¦Υ뤬ư뤳Ȥꤷޤonǰưoff\
ǰưޤ󡣥ǥեȤonǤ",
  "ǡѤƸǤ뤫ɤ\
ޤǥեȤonǤoffꤹȡΥ\
򤵤Ƥ䤬ꤷϼɤߤȤ\
갷ޤ",
  "numericalKeySelectonǤȤˡǸ򤷤Ȥ\
˸ɽΤޤޤǤʤꤷޤonξϸ\
λޤǥեȤoffǤ",
  "ɽƤȤʸᤴȤ˶Ƕڤ뤫ɤ\
ޤonǶڤޤǥեȤoffǤ",
  "ɤߤϤƤȤ˥ưԤˡʸñ̤ǰư\
ԤɤꤷޤǥեȤonǤoffˤȡ޻\
Ѵγñ̤ˤƥưޤʸƱͤ\
Ԥޤ",
  "onꤹɤߤϤƤʸȿžϰϤʤޤ\
ǥեȤoffǤ",
  "ǺǽɽƤ֤ǼԤȸ\
λɤߤΤΤȤɽ褦ˤʤޤܤ\
ڡɽ˥ޥƤʤɤonˤƤ\
ǤǥեȤoffǤ",
  "ХåڡǤäȤľΥ޻Ѵ줿ʸ\
޻뤫ɤꤷޤǥեȤoffǤ",
  "ʴѴؽԤɤꤷޤǥեȤonǤ",
  "֤Ǹ򤷤ñɽ֤äȤˡ\
ʸ򼡤ʸ˰ư뤫ɤꤷޤoffǥʸ˰ư\
ޤonǤϥʸѤޤ󡣥ǥեȤonǤ",
  "ǱʸǼʸذư褦ȤȤˡꤹ뤫ݤꤷޤ\
offꤹȺǺʸ᤬ʸˤʤޤǥեȤoffǤ",
  "ñϿʻꤷ塢ܺ٤ʻʬΤμԤݤ\
ꤷޤonǼԤoffǤϼ򤷤ޤ󡣥ǥեȤonǤ",
  "Ѵ򲿲󤫲ȸɽԤ褦ˤ\
ǤޤǤϤβ(,)ǻꤷޤ\
0ˤȲѴ\
ƤɽԤʤʤޤǥեȤ2ǡ2Ѵ\
Ȱɽˤʤޤ",
  NULL
};
