.\" Copyright 1994 NEC Corporation, Tokyo, Japan.
.\" 
.\" Permission to use, copy, modify, distribute and sell this software
.\" and its documentation for any purpose is hereby granted without
.\" fee, provided that the above copyright notice appear in all copies
.\" and that both that copyright notice and this permission notice
.\" appear in supporting documentation, and that the name of NEC
.\" Corporation not be used in advertising or publicity pertaining to
.\" distribution of the software without specific, written prior
.\" permission.  NEC Corporation makes no representations about the
.\" suitability of this software for any purpose.  It is provided "as
.\" is" without express or implied warranty.
.\" 
.\" NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
.\" NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
.\" USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
.\" OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
.\" PERFORMANCE OF THIS SOFTWARE.
.\" $Id: ccheck.man,v 1.2 2003/09/04 12:09:02 takasan Exp $
.TH CANNACHECK 1
.SH "NAME"
cannacheck \- Display information about Japanese input system Canna
.SH "SYNOPSIS"
.B "cannacheck [\-v]"
.SH "DESCRIPTION"
.PP
cannacheck displays the problems concerning use of Canna and the
related information.  It examines the following items:
.IP "-" 3
Customize file to be used
.IP "-" 3
Romaji-to-Kana conversion dictionary to be used
.IP "-" 3
Destination to which the server is to be connected.  Is it connectable?
.IP "-" 3
Dictionaries to be mounted. Are they mountable?
.IP "-" 3
Errors in the customize file
.PP
The problem(s) are displayed on the standard output if found.
.SH "OPTIONS"
.IP \-v 8
Displays all the above information including items that contain no problem.
.SH "FILES"
.IP "@(cannaLibDir)/cannahost" 36
Name of the host under which \fIcannaserver(1M)\fP is in operation.
.SH "SEE ALSO"
.br
cannaserver(1M), cannakill(1M), cannastat(1)
.SH "ENVIRONMENT"
.IP "CANNAHOST" 12
Specifies the name of the host under which \fIcannaserver(1M)\fP is in
operation.
.IP "CANNAFILE" 12
Specifies the initialize file (.canna).
