.\" Copyright 1994 NEC Corporation, Tokyo, Japan.
.\"
.\" Permission to use, copy, modify, distribute and sell this software
.\" and its documentation for any purpose is hereby granted without
.\" fee, provided that the above copyright notice appear in all copies
.\" and that both that copyright notice and this permission notice
.\" appear in supporting documentation, and that the name of NEC
.\" Corporation not be used in advertising or publicity pertaining to
.\" distribution of the software without specific, written prior
.\" permission.  NEC Corporation makes no representations about the
.\" suitability of this software for any purpose.  It is provided "as
.\" is" without express or implied warranty.
.\"
.\" NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
.\" NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
.\" USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
.\" OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
.\" PERFORMANCE OF THIS SOFTWARE.
.\"
.\" $Id: delwords.man,v 1.1.1.1 2002/10/19 08:27:33 aida_s Exp $
.TH DELWORDS 1
.SH "NAME"
delwords \- Deleting words from specified dictionary collectively
.SH "SYNOPSIS"
.B "delwords [{\-cs|\-cannaserver} \fIcannaserver\fP] dicname"
.SH "DESCRIPTION"
.PP
.I delwords
deletes words from specified dictionary according to the word
information from the standard input.  The standard input must be in a
format of ``Text Dictionary format'' of Canna.
.PP
.I dicname
must be a ``Text Dictionary format'' which can be rewritten.
.SH "OPTIONS"
.IP "\-cs \fIcannaserver\fP (or \-cannaserver \fIcannaserver\fP)" 12
Specifies the hostname on which the specified dictionary is expected
to exist.
.SH "EXAMPLE"
.nf
  % delwords mydic < remwords
.fi
.PP
Deletes words defined in \fIremwords\fP from \fImydic\fP.
.sp
.nf
  % catdic mydic | delwords mydic
.fi
.PP
Clears the contents of \fImydic\fP.
