.\" Copyright 1994 NEC Corporation, Tokyo, Japan.
.\"
.\" Permission to use, copy, modify, distribute and sell this software
.\" and its documentation for any purpose is hereby granted without
.\" fee, provided that the above copyright notice appear in all copies
.\" and that both that copyright notice and this permission notice
.\" appear in supporting documentation, and that the name of NEC
.\" Corporation not be used in advertising or publicity pertaining to
.\" distribution of the software without specific, written prior
.\" permission.  NEC Corporation makes no representations about the
.\" suitability of this software for any purpose.  It is provided "as
.\" is" without express or implied warranty.
.\"
.\" NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN 
.\" NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
.\" USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR 
.\" OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
.\" PERFORMANCE OF THIS SOFTWARE. 
.\"
.\" $Id: RkGetSta.man,v 1.1.1.1 2002/10/19 08:27:44 aida_s Exp $ NEC;
.TH "RKGETSTAT" "3"
.SH "NAME"
\f4RkGetStat\f1 \- get analysis information about the current candidate
.SH "SYNOPSIS"
.nf
.ft 4
#include <canna/RK.h>
int RkGetStat(cxnum, stat)
int cxnum;
Rkstat *stat;
.ft 1
.fi
.SH "DESCRIPTION"
\f2RkGetStat\f1 gets analysis information about the current candidate.  The fields of the structure \f2stat\f1 are loaded with the following:
.P
.RS
.IP "\f4bunnum\f1" 12n
Current clause number
.IP "\f4candnum\f1"
Current candidate number
.IP "\f4maxcand\f1"
Number of candidates for the current clause
.IP "\f4diccand\f1"
\f4maxcand\f1 less the mode specification of \f4RkBgnBun\f1(3)
.IP "\f4ylen\f1"
Byte length of the reading of the current candidate
.IP "\f4klen\f1"
Byte length of the kanji of the current candidate
.IP "\f4tlen\f1"
Number of words making up the current candidate
.RE
.SH "RETURN VALUE"
This function returns \f40\f1, or returns \f4-1\f1, without doing anything, if it has been run in a nonconversion mode context.
