.\" Copyright 1994 NEC Corporation, Tokyo, Japan.
.\"
.\" Permission to use, copy, modify, distribute and sell this software
.\" and its documentation for any purpose is hereby granted without
.\" fee, provided that the above copyright notice appear in all copies
.\" and that both that copyright notice and this permission notice
.\" appear in supporting documentation, and that the name of NEC
.\" Corporation not be used in advertising or publicity pertaining to
.\" distribution of the software without specific, written prior
.\" permission.  NEC Corporation makes no representations about the
.\" suitability of this software for any purpose.  It is provided "as
.\" is" without express or implied warranty.
.\"
.\" NEC CORPORATION DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
.\" INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN 
.\" NO EVENT SHALL NEC CORPORATION BE LIABLE FOR ANY SPECIAL, INDIRECT OR
.\" CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF 
.\" USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR 
.\" OTHER TORTUOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR 
.\" PERFORMANCE OF THIS SOFTWARE. 
.\"
.\" $Id: RkResize.man,v 1.1.1.1 2002/10/19 08:27:45 aida_s Exp $ NEC;
.TH "RKRESIZE" "3"
.SH "NAME"
\f4RkResize\f1 \- change the reading length of the current clause to len bytes
.SH "SYNOPSIS"
.nf
.ft 4
#include <canna/RK.h>
int RkResize(cxnum, len)
int cxnum;
int len;
.ft 1
.fi
.SH "DESCRIPTION"
\f2RkResize\f1 changes the reading length of the current clause to \f2len\f1 bytes and reconverts the right part of the current clause.  The value of \f2len\f1 must be adjusted to character boundaries in the EUC code.  The analysis result of the reconverted clause is destroyed because of the reading length change, but the analysis result of any other clause does not change.  The current clause does not change either.
.SH "RETURN VALUE"
This function returns the number of clauses after the change.
